
#include "ot4xb.ch"

//----------------------------------------------------------------------------------------------------------------------
proc main()
   local db, n, i, nStart, nRecNr
   local stm,aa, nAnzTestRec := 100

   set charset to OEM  //  - wegen Anzeige in CMD Box

   delete file test.db // hier immer UTF8 !

   set alternate to test.txt
   set alternate on

   cls
   ?
   ? "Existiert test.db noch, trotz Lschung: ",file("test.db")
   ?

   nRecNr := 0

   db := TSqLiteDb():Open("test.db")
   aa := db:exec("SELECT sqlite_version()")
   if ! empty(aa) // NIL wre mglich
      ? "sqlite_version():  ",aa[1,1] , valtype(aa[1,1])
   else
      ? "sqlite_version():  ",aa
   endif
   ?
   if ! db:lIsTable("t")
      db:exec( "CREATE TABLE t (id integer PRIMARY KEY AUTOINCREMENT UNIQUE, name, vorname, strasse, plz, ort )" ) // keine Umlaute in Feldnamen (zumindest bei mir)
   end

   ? time(),"Erzeuge",nAnzTestRec,"Stze ohne begin transaction"
   nStart := seconds()
   for n := 1 to nAnzTestRec
      @ row(),50 say n
      nRecNr++
      stm := db:exec_begin("INSERT INTO t(name, vorname, strasse, plz, ort)  VALUES (:name, :vorname, :strasse, :plz, :ort)")
      db:bind_textA(stm ,":name",   convToAnsiCP("Name  "+str(nRecNr,5)))
      db:bind_textA(stm ,":vorname",convToAnsiCP("Vorname  "+str(nRecNr,5)))
      db:bind_textA(stm ,":strasse",convToAnsiCP("Strae "+str(nRecNr,5)))
      db:bind_textA(stm ,":plz",    strZero(n,5))
      db:bind_textA(stm ,":ort",                 "Ort /\[|]{}"+str(nRecNr,5))
      db:exec_end(stm)
   next
   ? "Dauer: ",seconds()-nStart
   ?
   ? "Erzeuge",nAnzTestRec,"Stze MIT begin transaction"
   nStart := seconds()
   stm := db:exec_begin("BEGIN TRANSACTION")
   db:exec_end(stm)
   for n := 1 to nAnzTestRec
      @ row(),50 say n
      nRecNr++
      stm := db:exec_begin("INSERT INTO t(name, vorname, strasse, plz, ort)  VALUES (:name, :vorname, :strasse, :plz, :ort)")
      db:bind_textA(stm ,":name",   convToAnsiCP("Name  "+str(nRecNr,5)))
      db:bind_textA(stm ,":vorname",convToAnsiCP("Vorname  "+str(nRecNr,5)))
      db:bind_textA(stm ,":strasse",convToAnsiCP("Strae "+str(nRecNr,5)))
      db:bind_textA(stm ,":plz",    strZero(n,5))
      db:bind_textA(stm ,":ort",                 "Ort /\[|]{}"+str(nRecNr,5))
      db:exec_end(stm)
   next
   stm := db:exec_begin("END TRANSACTION")
   db:exec_end(stm)
   ? "Dauer: ",seconds()-nStart
   ?
   nStart := seconds()
   ? "Erzeuge 10000 Stze mit begin transaction"
   stm := db:exec_begin("BEGIN TRANSACTION")
   db:exec_end(stm)
   for n := 1 to 10000
      @ row(),50 say n
      nRecNr++
      stm := db:exec_begin("INSERT INTO t(name, vorname, strasse, plz, ort)  VALUES (:name, :vorname, :strasse, :plz, :ort)")
      db:bind_textA(stm ,":name",   "Name    "+str(nRecNr,5))
      db:bind_textA(stm ,":vorname","Vorname "+str(nRecNr,5))
      db:bind_textA(stm ,":strasse","Strasse "+str(nRecNr,5))
      db:bind_textA(stm ,":plz",               strZero(n,5))
      db:bind_textA(stm ,":ort",    "Ort     "+str(nRecNr,5))
      db:exec_end(stm)
   next
   stm := db:exec_begin("END TRANSACTION")
   db:exec_end(stm)
   ? "Dauer: ",seconds()-nStart

   ? time(),"Suche alle die '55' im Namen haben ... "
   nStart := seconds()
   stm := db:exec_begin("SELECT id,name, vorname, strasse, plz, ort FROM t WHERE name like '%55%' ORDER BY ID")
   // aa  := db:exec_end_ex(stm,,,"IICI" )
   aa  := db:exec_end(stm)

   ? time(), "Treffer: ",len(aa),"   Dauer: ",seconds()-nStart
   wait
   ? "lfdNr. ID    ,Name         ,Vorname      ,Strasse      ,Plz  ,Ort"
   for n := 1 to len(aa)
     ? str(n,5)+":",str(val(aa[n,1]),6)
     for i := 2 to len(aa[n])
        ?? ",",cUtf8ToOem(aa[n,i]) // Texte sind noch in UTF8 !
     next
   next

   ? "Zeige die Tabellen in der Datei:"
   aEval( db:aTableNames() , {|a,i| qout(str(i,3)+".",a)} )
   ?
   set alternate to

   memowrit("test.txt",convtoAnsiCP(memoread("test.txt")))


   db:Close()
   inkey(10)

return
